// LICENSE : MIT
"use strict";

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var EventEmitter = require("events");
var eventType = "CHANGE";

var LogQueue = function (_EventEmitter) {
    _inherits(LogQueue, _EventEmitter);

    function LogQueue() {
        _classCallCheck(this, LogQueue);

        var _this = _possibleConstructorReturn(this, Object.getPrototypeOf(LogQueue).call(this));

        _this._logs = [];
        return _this;
    }

    /**
     * listen on change event and return un listen function
     * @param {function()}changeHandler
     * @returns {function()}
     */


    _createClass(LogQueue, [{
        key: "onChange",
        value: function onChange(changeHandler) {
            var _this2 = this;

            this.on(eventType, changeHandler);
            return function () {
                _this2.removeListener(eventType, changeHandler);
            };
        }

        /**
         * consume logs
         * purge log queue. please use careful
         * @returns {Array.<*>}
         */

    }, {
        key: "consumeLogs",
        value: function consumeLogs() {
            var chunks = this._logs.slice();
            this.clear();
            return chunks;
        }
    }, {
        key: "addLog",
        value: function addLog(chunk) {
            if (chunk == undefined) {
                return;
            }
            this._logs.push(chunk);
            this.emit(eventType);
        }
    }, {
        key: "clear",
        value: function clear() {
            this._logs.length = 0;
        }
    }]);

    return LogQueue;
}(EventEmitter);

exports.default = LogQueue;
//# sourceMappingURL=LogQueue.js.map