// LICENSE : MIT
"use strict";

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _LogQueue = require("./LogQueue");

var _LogQueue2 = _interopRequireDefault(_LogQueue);

var _LoggerContext = require("./LoggerContext");

var _LoggerContext2 = _interopRequireDefault(_LoggerContext);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

/**
 * Logger is log interface.
 * @example
 *  const logger = new Logger();
 *  logger.log("you can log it!");
 *  // logger add the log to queue
 *  logger.start()
 *  // actually start logging
 *  // buffering logs are prune at this timing
 *  logger.log("you can log it!");
 *  // log log log
 */

var Logger = function () {
    function Logger() {
        _classCallCheck(this, Logger);

        this._isStarted = false;
        this._logQueue = new _LogQueue2.default();
        this._loggerContext = new _LoggerContext2.default(this._logQueue);
    }

    /**
     * @returns {LoggerContext}
     */


    _createClass(Logger, [{
        key: "log",


        /**
         * add chunk log to queue.
         * @param {*} chunk
         */
        value: function log(chunk) {
            // if not started the logger, only add log to queue
            this._logQueue.addLog(chunk);
            if (this._isStarted) {
                this._loggerContext.process();
            }
        }

        /**
         * Start logging
         */

    }, {
        key: "start",
        value: function start() {
            if (this._isStarted) {
                return;
            }
            // TODO: check connection
            // start process
            this._loggerContext.process();
            this._isStarted = true;
        }
    }, {
        key: "context",
        get: function get() {
            return this._loggerContext;
        }
    }]);

    return Logger;
}();

exports.default = Logger;
//# sourceMappingURL=Logger.js.map